   //////////////////////////////////////////////
  //        2.8" TOUCH SCREEN DEMO            //
 //                                          //
//           http://www.educ8s.tv           //
/////////////////////////////////////////////

#include <TimeLib.h>
#include <Adafruit_TFTLCD.h> 
#include <Adafruit_GFX.h>    
#include <TouchScreen.h>


#if defined(__SAM3X8E__)
#undef __FlashStringHelper::F(string_literal)
#define F(string_literal) string_literal
#endif


#define YP A2  // must be an analog pin, use "An" notation!
#define XM A1  // must be an analog pin, use "An" notation!
#define YM 6   // can be a digital pin
#define XP 7   // can be a digital pin

// For better pressure precision, we need to know the resistance
// between X+ and X- Use any multimeter to read it
// For the one we're using, its 300 ohms across the X plate
TouchScreen ts = TouchScreen(XP, YP, XM, YM, 300);

#define LCD_CS A3 
#define LCD_CD A2 
#define LCD_WR A1 
#define LCD_RD A0 
#define LCD_RESET A4 

// Assign human-readable names to some common 16-bit color values:
#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF
#define GRAY    0x7BEF
#define ORANGE  0xFCA0
#define PINK    0xF97F
#define BROWN   0x8200
#define VIOLET  0x9199
#define SILVER  0xA510
#define GOLD    0xA508
#define NAVY    0x000F
#define MAROON  0x7800
#define PURPLE  0x780F
#define OLIVE   0x7BE0
#define DGRAY   0x2104

Adafruit_TFTLCD tft(LCD_CS, LCD_CD, LCD_WR, LCD_RD, LCD_RESET);

#define MINPRESSURE 10
#define MAXPRESSURE 1000

#define TS_MINX 85
#define TS_MINY 120
#define TS_MAXX 900
#define TS_MAXY 900

boolean buttonEnabled = true;
int battery = 87;
int insulin = 76;
int bolus = 5;
int boluscount = 0;
int bolusvol = 2;
int bolusoff = 0;
int age = 20;
int weight = 70;
int mode = 1;
int alarm = 0;
boolean batterychanged=false; boolean insulinchanged=false; boolean minutechanged=false; boolean screenchanged = false;
int newbattery = 0;
int newinsulin = 0;
int newbolus = 0;
int dosevol = 1;
int dosetime =10;
int motorvol = 0;
int motortime = 0;
int tmp = 0;
int screen = 0;
int insulinalarm=5; 
int batteryalarm = 5;
float flow = 5.1; float flowmax = 90.0; float flowmin = 0.0;

///////////////// 0 // 1 // 2 // 3 // 4 // 5 // 6 // 7 // 8 // 9 // 10// 11// 12// 13// 14// 15// 16// 17// 18// 19// 20// 21// 22// 23//
float modeA[] = {-10, -1, 8, 40, 53, 60, 45, 25, 0, -10, -20, -25, -20, -10, 0, 10, 14, 10, 0, -10, -15, -20, -25, -20};
float modeB[] = {-10, -1, 8, 40, 53, 60, 45, 25, 0, -10, -20, -25, -20, -10, 0, 10, 14, 10, 0, -10, -15, -20, -25, -20};
float modeC[] = {-10, -1, 8, 40, 53, 60, 45, 25, 0, -10, -20, -25, -20, -10, 0, 10, 14, 10, 0, -10, -15, -20, -25, -20};
float modeD[] = {-10, -1, 8, 40, 53, 60, 45, 25, 0, -10, -20, -25, -20, -10, 0, 10, 14, 10, 0, -10, -15, -20, -25, -20};

float figure[180];

int setOption = 1;
int SDvalue = 30;

////////////////////////////////////////////////////////////////
// define the time pass by for the calculation of the insulin //
////////////////////////////////////////////////////////////////
int mininit = 0;
int indexmode = 0;

///////////////////
// Servo setting //
///////////////////
int incomingByte = 0;
int servo0 = 600;
int servo180 = 2100;
int inc = 20;
int pos = servo0;
int servoPin = 10;
int pulseInterval=2000;



void LowBattery()
{
  tft.fillScreen(BLACK);

  //Draw white frame
  tft.drawRect(4,0,319,240,WHITE);
  
  //Create Red Button
  tft.fillRect(50,60,230,40, RED);
  tft.drawRect(50,60,230,40,WHITE);
  tft.setCursor(60,68);
  tft.setTextColor(WHITE);
  tft.setTextSize(3);
  tft.print("Low Battery");

  //Print "Hello" Text
  tft.setCursor(60,150);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  tft.print("Press to Continue");
}

void LowInsulin()
{
  tft.fillScreen(BLACK);

  //Draw white frame
  tft.drawRect(4,0,319,240,WHITE);
  
  //Create Red Button
  tft.fillRect(50,60,230,40, RED);
  tft.drawRect(50,60,230,40,WHITE);
  tft.setCursor(60,68);
  tft.setTextColor(WHITE);
  tft.setTextSize(3);
  tft.print("Low Insulin");

  //Print "Hello" Text
  tft.setCursor(60,150);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  tft.print("Press to Continue");
}

void Header()
{
  //Draw black frame
  tft.fillRect(0,0,319,29,DGRAY);
  
  //Draw battery
  if (battery>49) {
  tft.fillRect(11,map(battery,1,100,25,5),13,25-map(battery,1,100,25,5), GREEN);
  } else {
  tft.fillRect(11,map(battery,1,100,25,5),13,25-map(battery,1,100,25,5), RED);
  }
  tft.drawRect(10,5,14,20,WHITE);

  //Draw insulin
  if (insulin>49) {
  tft.fillRect(31,map(insulin,1,100,25,5),13,25-map(insulin,1,100,25,5), GREEN);
  } else {
  tft.fillRect(31,map(insulin,1,100,25,5),13,25-map(insulin,1,100,25,5), RED);
  }
  tft.drawRect(31,5,14,20,PINK);

  
  //Draw mode of operation
  tft.drawRect(51,5,44,20,WHITE);
  tft.setCursor(55,8);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  if (mode==1){
    tft.print("M:A");    
  } 
  else if (mode==2) {
    tft.print("M:B");    
  }
  else if (mode==3) {
    tft.print("M:C");    
  }
  else if (mode==4) {
    tft.print("M:D");    
  }
  else {
    tft.print("M:-");    
  }

  //Draw clock
  tft.setCursor(250,8);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  tft.print(hour());
  tft.print(":");
  if (minute()<10){
    tft.print("0");
  }
  tft.print(minute());

}

void Footer()
{
  //Draw black frame
  tft.fillRect(4,211,319,29,DGRAY);
  tft.drawRect(4,211,319,29,WHITE);
  tft.drawRect(160,211,159,29,WHITE);
  
  //Draw OPERATION
  tft.setTextColor(WHITE);
  tft.setTextSize(3);
  tft.setCursor(200,214);
  tft.print("BASAL");  

  tft.setCursor(40,214);
  if (bolusoff == 1) {
      tft.setTextColor(RED);  
      }
  tft.print("BOLUS");

}

void SideBar()
{
  //Draw black frame
  tft.fillRect(230,30,90,179,DGRAY);
  tft.fillRect(235,40,80,29,BLUE);
  tft.drawRect(235,40,80,29,WHITE);
  
  //Draw clock
  tft.setCursor(238,47);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);

  if (screen == 0) {
    tft.setCursor(246,47);
    tft.print("SETUP");
  } else {
    tft.setCursor(238,47);
    tft.print(" BACK ");  
  }
}

void Splash(){
  
  //Draw white frame
  tft.drawRect(4,0,319,240,WHITE);
  
  //Print "Hello" Text
  tft.setCursor(80,30);
  tft.setTextColor(WHITE);
  tft.setTextSize(4);
  tft.print("Welcome");
  
  tft.setCursor(80,100);
  tft.setTextColor(PINK);
  tft.setTextSize(4);
  tft.print("Zlati's");
  
  //Create Red Button
  tft.fillRect(60,180, 200, 40, RED);
  tft.drawRect(60,180,200,40,WHITE);
  tft.setCursor(80,188);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  tft.print("Insulin Pump");

}

void Settings() {
  tft.fillRect(0,30,229,179,BLACK);
  
  tft.setCursor(5,40);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  tft.print("MODE:             ");

  tft.setCursor(5,70);
  tft.print("Bolus/day:        ");

  tft.setCursor(5,100);
  tft.print("Age:              ");

  tft.setCursor(5,130);
  tft.print("Weight:           ");

  tft.setTextColor(RED);
  
  tft.setCursor(5,160);
  tft.print("% Insulin:        ");

  tft.setCursor(5,190);
  tft.print("% Battery:        ");

  tft.setTextColor(GREEN);
  
  if (mode == 1) {
      tft.setCursor(168,40);
      tft.print("A");
  } else if (mode == 2) {
      tft.setCursor(168,40);
      tft.print("B");
  } else if(mode == 3) {
      tft.setCursor(168,40);
      tft.print("C");
  } else {
      tft.setCursor(168,40);
      tft.print("D");
      mode = 4;
  } 

      tft.setCursor(168,70);
      tft.print(bolus);

      tft.setCursor(168,100);
      tft.print(age);

      tft.setCursor(168,130);
      tft.print(weight);

      tft.setCursor(168,160);
      tft.print(insulinalarm);

      tft.setCursor(168,190);
      tft.print(batteryalarm);

      //Create + and -
      tft.fillRect(250,90, 50, 40, GRAY);
      tft.drawRect(250,90, 50, 40,WHITE);
  
      tft.fillRect(250,150, 50, 40, GRAY);
      tft.drawRect(250,150, 50, 40,WHITE);

      tft.setCursor(266,96);
      tft.setTextColor(WHITE);
      tft.setTextSize(4);
      tft.print("+");
      tft.setCursor(266,157);
      tft.setTextColor(WHITE);
      tft.setTextSize(4);
      tft.print("-");

      tft.drawRect(2,38+(setOption-1)*30, 198, 26,WHITE);
  
}

void Chart() {
  //Draw black frame
  tft.fillRect(0,30,229,179,DGRAY);

    //Draw clock
  tft.setCursor(242,120);
  tft.setTextColor(BLUE);
  tft.setTextSize(3);
  tft.print(flow);
  tft.setCursor(242,150);
  tft.setTextColor(WHITE);
  tft.setTextSize(2);
  tft.print("mg/min");

  tft.drawRect(10,60,180,30,WHITE);
  tft.drawRect(10,90,180,30,WHITE);
  tft.drawRect(10,120,180,30,WHITE);
  tft.drawRect(10,150,180,30,WHITE);

  tft.drawRect(10,map(flowmax,0.0,100.0,180,60),180,1,RED);
  tft.drawRect(10,map(flowmin,0.0,100.0,180,60),180,1,RED);  

  tft.setCursor(195,55);
  tft.setTextColor(WHITE);
  tft.setTextSize(1);
  tft.print("99.0");

  tft.setCursor(195,85);
  tft.print("75.0");

  tft.setCursor(195,115);
  tft.print("50.0");

  tft.setCursor(195,145);
  tft.print("25.0");

  for(int k=0;k<180;k++){
    tft.drawRect(10+k,map(figure[k],0.0,100.0,178,58),2,2,YELLOW);
  }
}

void ClearLCD() {
    tft.fillScreen(BLACK);
}

void Screen0() {
  Header();
  Footer();
  SideBar();
  Chart();
}

void Screen1() {
  Header();
  Footer();
  SideBar();
  Settings();
}

void defineflow(){
    indexmode = hour();

    if (mode==1){
      flow = (SDvalue + modeA[indexmode])/60.0;
    }
    else if (mode==2){
      flow = (SDvalue + modeB[indexmode])/60.0;
    }
    if (mode==3){
      flow = (SDvalue + modeC[indexmode])/60.0;
    }
    if (mode==4){
      flow = (SDvalue + modeD[indexmode])/60.0;
    }

}

void FigRefresh(){
  defineflow();
  for(int k=1;k<180;k++){
    figure[k-1]=figure[k];
  }
  figure[179]=figure[178]+flow+float(newbolus*bolusvol);

  newbolus=0;
      Serial.print(indexmode); 
      Serial.print(", ");
      Serial.print(flow); 
      Serial.print(", ");
      Serial.print(float(figure[178])); 
      Serial.print(", ");
      Serial.println(float(figure[179]));
}


void setup() {
  Serial.begin(9600);
  Serial.print("Starting...");

  setTime(12,1,00,06,02,2019);
  
  tft.reset();
  tft.begin(0x9341);  
  tft.setRotation(1);

  for(int k=0;k<180;k++) {
    figure[k]=0;
  }
  defineflow();
  //ClearLCD();

  Splash();
  delay(10000);

  ClearLCD();
  
  screen=0;
  Screen0();

  tmp=minute();
  mininit=minute();
  indexmode=hour();

  

//////////////////////
// Initialize Servo //
//////////////////////
  pinMode(servoPin, OUTPUT);
  
}


void loop() 
{
  TSPoint p = ts.getPoint();  //Get touch point
   //This is important, because the libraries are sharing pins
   pinMode(XM, OUTPUT);
   pinMode(YP, OUTPUT);


  if (p.z > MINPRESSURE && p.z < MAXPRESSURE) {
  
   p.x = map(p.x, TS_MAXX, TS_MINX, 0, 320);
   p.y = map(p.y, TS_MAXY, TS_MINY, 240, 0);

   Serial.print("X = "); Serial.print(p.x);
   Serial.print("\tY = "); Serial.print(p.y);
   Serial.print("\tPressure = "); Serial.print(p.z);

   Serial.print("\tins = "); Serial.print(insulin);   
   Serial.print("\tscr = "); Serial.print(screen);
   Serial.print("\tscrch = "); Serial.print(screenchanged);
   Serial.print("\tinsl = "); Serial.print(insulinalarm);
   Serial.print("\tBattery = "); Serial.println(battery);   
   Serial.print("\n");

   if (screen > 1) {
    screen = 0;
    screenchanged = true;
   }
   else if (screen <2) {
        
       if(p.x>0 && p.x<160 && p.y>210 && p.y<250)// The user has pressed the BOLUS
       {
        boluscount = boluscount + 1; //Reduce bolus
        newbolus = 1;
        if (boluscount<=bolus) {
          insulin = insulin - bolusvol; //Reduce insulin
          insulinchanged = true;          
        } else {
          boluscount = bolus +1;
          bolusoff = 1;
          Footer();
        }
       }
       else if (p.x>235 && p.x<315 && p.y>59 && p.y<80) // The user has pressed the SCREEN
       {
         screen = 1 - screen;
         screenchanged = true;
       }

       // Settings and options
       if (screen==1){
          // Incrase or decrease
          if(p.x>250 && p.x<300 && p.y>90 && p.y<145)// The user has pressed the +
                   {
                    if (setOption == 1) {
                      mode = mode + 1;
                      if (mode>4){ mode = 4;}
                    }
                    if (setOption == 2) {
                      bolus = bolus + 1;
                      if (bolus>8){ bolus = 8;}
                    }
                    if (setOption == 3) {
                      age = age + 1;
                      if (age>99){ age = 99;}
                    }
                    if (setOption == 4) {
                      weight = weight + 1;
                      if (weight>200){ weight = 200;}
                    }
                    if (setOption == 5) {
                      insulinalarm = insulinalarm + 1;
                      if (insulinalarm>15){ insulinalarm = 15;}
                    }
                    if (setOption == 6) {
                      batteryalarm = batteryalarm + 1;
                      if (batteryalarm>15){ batteryalarm = 15;}
                    }
                    Settings();
                   }
          else if(p.x>250 && p.x<300 && p.y>150 && p.y<200)// The user has pressed the -
                   {
                    if (setOption == 1) {
                      mode = mode - 1;
                      if (mode<1){ mode = 1;}
                    }
                    if (setOption == 2) {
                      bolus = bolus - 1;
                      if (bolus<1){ bolus = 1;}
                    }
                    if (setOption == 3) {
                      age = age - 1;
                      if (age<10){ age = 10;}
                    }
                    if (setOption == 4) {
                      weight = weight - 1;
                      if (weight<30){ weight = 30;}
                    }
                    if (setOption == 5) {
                      insulinalarm = insulinalarm - 1;
                      if (insulinalarm<5){ insulinalarm = 5;}
                    }
                    if (setOption == 6) {
                      batteryalarm = batteryalarm - 1;
                      if (batteryalarm<5){ batteryalarm = 5;}
                    }
                    Settings();
                   }

          // Select option
          if(p.x>0 && p.x<200 && p.y>38 && p.y<64)// The user has selected option 1
                   {
                    setOption = 1; //Set Mode of operation
                    Settings();
                   }
          else if(p.x>0 && p.x<200 && p.y>68 && p.y<94)// The user has selected option 2
                   {
                    setOption = 2; //Set maximum number of bolus per day
                    Settings();
                   }
          else if(p.x>0 && p.x<200 && p.y>98 && p.y<124)// The user has selected option 3
                   {
                    setOption = 3; //Set age
                    Settings();
                   }
          else if(p.x>0 && p.x<200 && p.y>128 && p.y<154)// The user has selected option 4
                   {
                    setOption = 4; //Set weight
                    Settings();
                   }
          else if(p.x>0 && p.x<200 && p.y>158 && p.y<184)// The user has selected option 5
                   {
                    setOption = 5; //Set Alarm % insulin
                    Settings();
                   }
          else if(p.x>0 && p.x<200 && p.y>188 && p.y<210)// The user has selected option 6
                   {
                    setOption = 6; //Set Alarm % battery
                    Settings();
                   }
          
        
       }
  } //
  
  }

  if (tmp!=minute()) {  //minute()  
    minutechanged = true;
    mininit = mininit +1;
    newbattery = newbattery + 1;
  }
  tmp = minute();
  if (minute()==0) {
    mininit = minute();
    indexmode=hour();
  }

  if (hour()==0) {
    newbolus=0;
    boluscount = 0;
    bolusoff = 0;
    Footer();
  }
  if (newbattery>36) { 
    battery = battery - 1;
    batterychanged = true;
    newbattery = 0;
  }

  if ((insulin<insulinalarm) && (screen!=3)){
    screen = 3;
    screenchanged = true;
  }

  if ((battery<batteryalarm) && (screen !=2)){
    screen = 2;
    screenchanged = true;
  }

  if (batterychanged || insulinchanged || minutechanged) {
     if (screen<2){
      Header();
     }
     if ((screen==0) && (minutechanged || insulinchanged)) {
      Chart();
      FigRefresh();
     }
     batterychanged = false;
     insulinchanged = false;
     minutechanged = false;
  }
  
  if (screenchanged) {
    ClearLCD();
    screenchanged = false;
    if (screen > 2) {
      LowInsulin();
    }
    else if (screen == 2) {
      LowBattery();
    }
    else if (screen == 1) {
      Screen1();
    }
    else if (screen == 0) {
      Screen0();
    }

  }

  
}

